<template>
  <div class="table_page">
    <div>
      <el-input style="width: 240px; margin-right: 10px;" suffix-icon="Search" placeholder="请输入商品名称"  size="default"
                v-model="productName"></el-input>
      <el-button type="primary" @click="onSearch(productName)" style="margin-right: 10px;" size="default">
        搜索
      </el-button>
      <el-select v-model="productType" @change="(event: any) => searchByType(event)" placeholder="商品类别"
                 style="width: 240px;  margin-right: 10px;" size="default" :clearable="true">
        <el-option v-for="item in typeList" :key="item.value" :label="item.label" :value="item.value1"/>
      </el-select>
      <el-select v-model="state" placeholder="商品状态" @change="(event: any) => searchByState(event)" size="default"
                 style="width: 240px;  margin-right: 10px;">
        <el-option label="已上架" value="1"/>
        <el-option label="已下架" value="0"/>
      </el-select>
      <el-button type="warning" @click="reset" size="default">重置</el-button>
    </div>
    <div style="margin: 15px 0">
      <el-popconfirm class="ml-5" confirm-button-text='确定' cancel-button-text='取消' icon="InfoFilled" icon-color="red"
                     title="您确定批量删除这些数据吗？" @confirm="delBatch" width=180>
        <template #reference>
          <el-button style="height: 25px" class="ml-5" type="danger">批量删除
            <el-icon style="margin-left: 5px;">
              <Remove/>
            </el-icon>
          </el-button>
        </template>
      </el-popconfirm>
    </div>
    <!-- 数据展示 -->
    <el-table :data="tableData" border stripe header-cell-class-name="headerBg"
              :cell-style="{ 'text-align': 'center', 'font-size': '16px' }" @selection-change="handleSelectionChange"
              @select="selectChange"
              :header-cell-style="{ 'text-align': 'center' }">
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="id" label="商品编号" width="80">
        <template #default="{ $index }">
          {{ $index + 1 }}
        </template>
      </el-table-column>
      <el-table-column prop="goodImg" label="商品图片">
        <template #default="scope">
          <img :src="downloadUrl + scope.row.goodImg.split(';')[0]" alt="" style="height: 50px;">
        </template>
      </el-table-column>
      <el-table-column prop="name" label="商品名称"></el-table-column>
      <el-table-column prop="price" label="商品价格" width="180">
        <template #default="scope">
          {{ scope.row.price }} 元
        </template>
      </el-table-column>
      <el-table-column prop="type" label="商品类型"></el-table-column>
      <el-table-column prop="inventory" label="商品数量"></el-table-column>
      <el-table-column label="商品状态">
        <template #default="scope">
          <span style="margin-left: 10px" v-if="scope.row.isShelves == 1">上架</span>
          <span style="margin-left: 10px" v-if="scope.row.isShelves == 0">下架</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" width="250px">
        <template #default="scope">
          <el-button size="small" @click="ReviseOrView(scope.$index, scope.row , 0)">
            详情
          </el-button>
          <el-button size="small" @click="ReviseOrView(scope.$index, scope.row, 1)">
            编辑
          </el-button>
          <el-button size="small" @click="handleOff(scope.$index, scope.row)">
            <div v-if="scope.row.isShelves == 1">下架</div>
            <div v-if="scope.row.isShelves == 0">上架</div>
          </el-button>
          <el-popconfirm class="ml-5" confirm-button-text='确定' cancel-button-text='取消' icon="InfoFilled"
                         icon-color="red"
                         title="是否确认删除" @confirm="deleteProduct(scope.row.id)" width=180>
            <template #reference>
              <el-button class="ml-5" type="danger">删除</el-button>
            </template>
          </el-popconfirm>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页器 -->
    <div style="padding: 10px 0">
      <el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange"
                     :current-page="searchParams.current" :page-size="searchParams.pageSize" :page-sizes="[5, 10, 15, 20]"
                     :small="null" :disabled="null" :background="null" layout="total, sizes, prev, pager, next, jumper"
                     :total="total"/>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ElMessage } from 'element-plus';
import {ref, onMounted, inject} from 'vue';
import myAxios from "@/api/myAxios";
import { useRouter } from "vue-router";
import {downloadUrl} from '@/utils/formatImgUpload'

const editForm = ref({})
const router = useRouter();  //路由
const total = ref(0); //总页数
const idList = ref<Number[]>([]);
const searchParams: any = ref({ //封装分页
  current: 1, //当前页码
  pageSize: 5, //每页显示条数
  sortField: "id",  //根据ID分类
  sortOrder: "descend" //降序
})
const productName = ref('');
const state = ref('');  //根据商品上架状态select栏
const tableData: any = ref([]);  //实体类商品表格
const reload: any = inject("reload")  //页面重新刷新
const typeList: any = ref([
  {
    value1: '',
    label: ''
  }
])
const productType = ref('') //商品类别
onMounted(() => { //页面加载时获取商品列表和分类页表
  getProductList()
  getTypeList()
})
const getProductList = async () => {
  try {
    const res = await myAxios.post('/goods/list/page', {...searchParams.value});
    // console.log('res--->', res.data)
    if (res.data.code === 1) {
      tableData.value = res.data.data.records;
      total.value = parseInt(res.data.data.total)  //总数据量，用于分页
    } else {
      ElMessage({
        message: '获取数据失败',
      });
      return;
    }
  } catch (error) {
    ElMessage({
      message: '发生错误',
    });
  }
}
const getTypeList = async () => {
  const res = await myAxios.post('/category/list', {})  //获取商品列表
  for (let key in res.data.data) {    //循环赋值
    typeList.value[key] = {
      value1: res.data.data[key].typeName,
      label: res.data.data[key].typeName
    }
  }
}

const searchByType = (event: any) => { //通过类别搜索
  searchParams.value.type = event
  searchParams.value.current = 1
  getProductList()
}
const searchByState = (event: any) => {  //通过商品是否上架/下架搜索
  searchParams.value.isShelves = event
  searchParams.value.current = 1
  getProductList()
}
//删除商品
const deleteProduct = async (index: number) => {
  console.log(typeof index)
  const res = await myAxios.post('/goods/delete', {id: index})
  console.log(res)
  if (res.data.code === 1) {
    ElMessage({
      type: 'success',
      message: '删除成功',
    })
    await getProductList()
  }
  await getTypeList()
}
//详情或编辑 
const ReviseOrView = (index: number, row: any, flag: number) => {
  router.push({
    name: '商品详情',
    params: {
      id: row.id,
      flag: flag
    }
  })
}
//下架商品
const handleOff = async (index: number, row: any) => {
  // console.log('当前行--->',row)
  row.isShelves ? row.isShelves = 0 : row.isShelves = 1  //三元运算符  改变那一行的上架值
  editForm.value = row;
  const res = await myAxios.post('/goods/update', {...editForm.value})
  if (res.data.code === 1) {
    ElMessage({
      type: 'success',
      message: '更新成功'
    })
  }
}
//处理行数大小变化
const handleSizeChange = (newSize: any) => {
  searchParams.value.pageSize = newSize //新的页面数
  getProductList()
}
//处理当前表格变化
const handleCurrentChange = (Current: any) => {
  searchParams.value.current = Current
  getProductList()
}
//重置按钮
const reset = () => {
  reload()
};

//批量删除
const delBatch = async () => {
  console.log(idList.value);
  const res = await myAxios.post('/goods/delBatch', {
    idList: idList.value
  })
  console.log(res.data);
  if (res.data.code === 1) {
    ElMessage({
      type: 'success',
      message: '批量删除成功'
    })
    getProductList()
  } else {
    ElMessage.error('删除失败')
  }
}
const handleSelectionChange = () => {
}
const selectChange = (selection: any, row: any) => {   //selction是对象数组，row是当前行对象
  idList.value.splice(0, idList.value.length)   //删掉
  selection.forEach((item: any) => {
    idList.value.push(item.id)
  })
  // console.log('idList--->',idList.value);
}

//查询
const onSearch = (value: string) => {
  searchParams.value.name = value
  searchParams.value.current = 1
  getProductList()
}
</script>

<style scoped>
.table_page {
  min-width: 1000px;
  overflow: auto;
}
</style>